/[gentoo-x86]/eclass/linux-info.eclass
Gentoo

Diff of /eclass/linux-info.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.39 Revision 1.77
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.39 2006/02/08 12:57:52 brix Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.77 2010/01/10 08:25:55 robbat2 Exp $
4# 4#
5# Description: This eclass is used as a central eclass for accessing kernel
6# related information for sources already installed.
7# It is vital for linux-mod to function correctly, and is split
8# out so that any ebuild behaviour "templates" are abstracted out
9# using additional eclasses.
10#
11# Maintainer: John Mylchreest <johnm@gentoo.org> 5# Original author: John Mylchreest <johnm@gentoo.org>
12# Copyright 2004 Gentoo Linux 6# Maintainer: kernel-misc@gentoo.org
13# 7#
14# Please direct your bugs to the current eclass maintainer :) 8# Please direct your bugs to the current eclass maintainer :)
9
10# @ECLASS: linux-info.eclass
11# @MAINTAINER:
12# kernel-misc@gentoo.org
13# @BLURB: eclass used for accessing kernel related information
14# @DESCRIPTION:
15# This eclass is used as a central eclass for accessing kernel
16# related information for source or binary already installed.
17# It is vital for linux-mod.eclass to function correctly, and is split
18# out so that any ebuild behaviour "templates" are abstracted out
19# using additional eclasses.
20#
21# "kernel config" in this file means:
22# The .config of the currently installed sources is used as the first
23# preference, with a fall-back to bundled config (/proc/config.gz) if available.
15 24
16# A Couple of env vars are available to effect usage of this eclass 25# A Couple of env vars are available to effect usage of this eclass
17# These are as follows: 26# These are as follows:
18# 27
19# Env Var Option Description 28# @ECLASS-VARIABLE: KERNEL_DIR
20# KERNEL_DIR <string> The directory containing kernel the target kernel 29# @DESCRIPTION:
21# sources. 30# A string containing the directory of the target kernel sources. The default value is
31# "/usr/src/linux"
32
33# @ECLASS-VARIABLE: CONFIG_CHECK
34# @DESCRIPTION:
22# CONFIG_CHECK <string> a list of .config options to check for before 35# A string containing a list of .config options to check for before
23# proceeding with the install. ie: CONFIG_CHECK="MTRR" 36# proceeding with the install.
37#
38# e.g.: CONFIG_CHECK="MTRR"
39#
24# You can also check that an option doesn't exist by 40# You can also check that an option doesn't exist by
25# prepending it with an exclamation mark (!). 41# prepending it with an exclamation mark (!).
42#
26# ie: CONFIG_CHECK="!MTRR" 43# e.g.: CONFIG_CHECK="!MTRR"
44#
27# To simply warn about a missing option, prepend a '~'. 45# To simply warn about a missing option, prepend a '~'.
28# ERROR_CFG <string> The error message to display when the above check 46# It may be combined with '!'.
47#
48# In general, most checks should be non-fatal. The only time fatal checks should
49# be used is for building kernel modules or cases that a compile will fail
50# without the option.
51#
52# This is to allow usage of binary kernels, and minimal systems without kernel
53# sources.
54
55# @ECLASS-VARIABLE: ERROR_<CFG>
56# @DESCRIPTION:
57# A string containing the error message to display when the check against CONFIG_CHECK
29# fails. <CFG> should reference the appropriate option 58# fails. <CFG> should reference the appropriate option used in CONFIG_CHECK.
30# as above. ie: ERROR_MTRR="MTRR exists in the .config 59#
31# but shouldn't!!" 60# e.g.: ERROR_MTRR="MTRR exists in the .config but shouldn't!!"
32# KBUILD_OUTPUT <string> This is passed on commandline, or can be set from 61
33# the kernel makefile. This contains the directory 62# @ECLASS-VARIABLE: KBUILD_OUTPUT
63# @DESCRIPTION:
64# A string passed on commandline, or set from the kernel makefile. It contains the directory
34# which is to be used as the kernel object directory. 65# which is to be used as the kernel object directory.
35 66
36# There are also a couple of variables which are set by this, and shouldn't be 67# There are also a couple of variables which are set by this, and shouldn't be
37# set by hand. These are as follows: 68# set by hand. These are as follows:
38# 69
39# Env Var Option Description 70# @ECLASS-VARIABLE: KV_FULL
40# KV_FULL <string> The full kernel version. ie: 2.6.9-gentoo-johnm-r1 71# @DESCRIPTION:
41# KV_MAJOR <integer> The kernel major version. ie: 2 72# A read-only variable. It's a string containing the full kernel version. ie: 2.6.9-gentoo-johnm-r1
42# KV_MINOR <integer> The kernel minor version. ie: 6 73
43# KV_PATCH <integer> The kernel patch version. ie: 9 74# @ECLASS-VARIABLE: KV_MAJOR
44# KV_EXTRA <string> The kernel EXTRAVERSION. ie: -gentoo 75# @DESCRIPTION:
45# KV_LOCAL <string> The kernel LOCALVERSION concatenation. ie: -johnm 76# A read-only variable. It's an integer containing the kernel major version. ie: 2
46# KV_DIR <string> The kernel source directory, will be null if 77
78# @ECLASS-VARIABLE: KV_MINOR
79# @DESCRIPTION:
80# A read-only variable. It's an integer containing the kernel minor version. ie: 6
81
82# @ECLASS-VARIABLE: KV_PATCH
83# @DESCRIPTION:
84# A read-only variable. It's an integer containing the kernel patch version. ie: 9
85
86# @ECLASS-VARIABLE: KV_EXTRA
87# @DESCRIPTION:
88# A read-only variable. It's a string containing the kernel EXTRAVERSION. ie: -gentoo
89
90# @ECLASS-VARIABLE: KV_LOCAL
91# @DESCRIPTION:
92# A read-only variable. It's a string containing the kernel LOCALVERSION concatenation. ie: -johnm
93
94# @ECLASS-VARIABLE: KV_DIR
95# @DESCRIPTION:
96# A read-only variable. It's a string containing the kernel source directory, will be null if
47# KERNEL_DIR is invalid. 97# KERNEL_DIR is invalid.
48# KV_OUT_DIR <string> The kernel object directory. will be KV_DIR unless 98
49# koutput is used. This should be used for referencing 99# @ECLASS-VARIABLE: KV_OUT_DIR
50# .config. 100# @DESCRIPTION:
101# A read-only variable. It's a string containing the kernel object directory, will be KV_DIR unless
102# KBUILD_OUTPUT is used. This should be used for referencing .config.
103
104# @ECLASS-VARIABLE: I_KNOW_WHAT_I_AM_DOING
105# @DESCRIPTION:
106# Temporary variable for the migration to making linux-info non-fatal.
51 107
52# And to ensure all the weirdness with crosscompile 108# And to ensure all the weirdness with crosscompile
53inherit toolchain-funcs versionator 109inherit toolchain-funcs versionator
54 110
55EXPORT_FUNCTIONS pkg_setup 111EXPORT_FUNCTIONS pkg_setup
56 112
57DEPEND="virtual/linux-sources" 113DEPEND=""
58RDEPEND="" 114RDEPEND=""
115
116[ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && \
117DEPEND="kernel_linux? ( virtual/linux-sources )"
59 118
60# Overwritable environment Var's 119# Overwritable environment Var's
61# --------------------------------------- 120# ---------------------------------------
62KERNEL_DIR="${KERNEL_DIR:-${ROOT}usr/src/linux}" 121KERNEL_DIR="${KERNEL_DIR:-${ROOT}usr/src/linux}"
63 122
67case ${ARCH} in 126case ${ARCH} in
68 ppc) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";; 127 ppc) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
69 ppc64) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";; 128 ppc64) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
70esac 129esac
71 130
72# These are legacy wrappers for toolchain-funcs. 131# @FUNCTION: set_arch_to_kernel
73# I dont like them here, but oh well. 132# @DESCRIPTION:
133# Set the env ARCH to match what the kernel expects.
74set_arch_to_kernel() { export ARCH="$(tc-arch-kernel)"; } 134set_arch_to_kernel() { export ARCH=$(tc-arch-kernel); }
135# @FUNCTION: set_arch_to_portage
136# @DESCRIPTION:
137# Set the env ARCH to match what portage expects.
75set_arch_to_portage() { export ARCH="$(tc-arch)"; } 138set_arch_to_portage() { export ARCH=$(tc-arch); }
76 139
77# qeinfo "Message" 140# qeinfo "Message"
78# ------------------- 141# -------------------
79# qeinfo is a quiet einfo call when EBUILD_PHASE 142# qeinfo is a quiet einfo call when EBUILD_PHASE
80# should not have visible output. 143# should not have visible output.
95qeerror() { qout eerror "${@}" ; } 158qeerror() { qout eerror "${@}" ; }
96 159
97# File Functions 160# File Functions
98# --------------------------------------- 161# ---------------------------------------
99 162
100# getfilevar accepts 2 vars as follows: 163# @FUNCTION: getfilevar
101# getfilevar <VARIABLE> <CONFIGFILE> 164# @USAGE: variable configfile
102 165# @RETURN: the value of the variable
166# @DESCRIPTION:
167# It detects the value of the variable defined in the file configfile. This is
168# done by including the configfile, and printing the variable with Make.
169# It WILL break if your makefile has missing dependencies!
103getfilevar() { 170getfilevar() {
104local ERROR workingdir basefname basedname myARCH="${ARCH}" 171local ERROR basefname basedname myARCH="${ARCH}"
105 ERROR=0 172 ERROR=0
106 173
107 [ -z "${1}" ] && ERROR=1 174 [ -z "${1}" ] && ERROR=1
108 [ ! -f "${2}" ] && ERROR=1 175 [ ! -f "${2}" ] && ERROR=1
109 176
111 then 178 then
112 echo -e "\n" 179 echo -e "\n"
113 eerror "getfilevar requires 2 variables, with the second a valid file." 180 eerror "getfilevar requires 2 variables, with the second a valid file."
114 eerror " getfilevar <VARIABLE> <CONFIGFILE>" 181 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
115 else 182 else
116 workingdir="${PWD}"
117 basefname="$(basename ${2})" 183 basefname="$(basename ${2})"
118 basedname="$(dirname ${2})" 184 basedname="$(dirname ${2})"
119 unset ARCH 185 unset ARCH
120 186
121 cd "${basedname}" 187 echo -e "e:\\n\\t@echo \$(${1})\\ninclude ${basefname}" | \
122 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \ 188 make -C "${basedname}" M="${S}" ${BUILD_FIXES} -s -f - 2>/dev/null
123 make ${BUILD_FIXES} -s -f - e 2>/dev/null
124 cd "${workingdir}"
125 189
126 ARCH=${myARCH} 190 ARCH=${myARCH}
127 fi 191 fi
128} 192}
129 193
194# @FUNCTION: getfilevar_noexec
195# @USAGE: variable configfile
196# @RETURN: the value of the variable
197# @DESCRIPTION:
198# It detects the value of the variable defined in the file configfile.
199# This is done with sed matching an expression only. If the variable is defined,
200# you will run into problems. See getfilevar for those cases.
201getfilevar_noexec() {
202 local ERROR basefname basedname mycat myARCH="${ARCH}"
203 ERROR=0
204 mycat='cat'
205
206 [ -z "${1}" ] && ERROR=1
207 [ ! -f "${2}" ] && ERROR=1
208 [ "${2%.gz}" != "${2}" ] && mycat='zcat'
209
210 if [ "${ERROR}" = 1 ]
211 then
212 echo -e "\n"
213 eerror "getfilevar_noexec requires 2 variables, with the second a valid file."
214 eerror " getfilevar_noexec <VARIABLE> <CONFIGFILE>"
215 else
216 ${mycat} "${2}" | \
217 sed -n \
218 -e "/^[[:space:]]*${1}[[:space:]]*=[[:space:]]*\(.*\)\$/{
219 s,^[^=]*[[:space:]]*=[[:space:]]*,,g ;
220 s,[[:space:]]*\$,,g ;
221 p
222 }"
223 fi
224}
225
226# @PRIVATE-VARIABLE: _LINUX_CONFIG_EXISTS_DONE
227# @DESCRIPTION:
228# This is only set if one of the linux_config_*exists functions has been called.
229# We use it for a QA warning that the check for a config has not been performed,
230# as linux_chkconfig* in non-legacy mode WILL return an undefined value if no
231# config is available at all.
232_LINUX_CONFIG_EXISTS_DONE=
233
234linux_config_qa_check() {
235 local f="$1"
236 if [ -z "${_LINUX_CONFIG_EXISTS_DONE}" ]; then
237 ewarn "QA: You called $f before any linux_config_exists!"
238 ewarn "QA: The return value of $f will NOT gaurenteed later!"
239 fi
240}
241
242# @FUNCTION: linux_config_src_exists
243# @RETURN: true or false
244# @DESCRIPTION:
245# It returns true if .config exists in a build directory otherwise false
246linux_config_src_exists() {
247 export _LINUX_CONFIG_EXISTS_DONE=1
248 [ -s "${KV_OUT_DIR}/.config" ]
249}
250
251# @FUNCTION: linux_config_bin_exists
252# @RETURN: true or false
253# @DESCRIPTION:
254# It returns true if .config exists in /proc, otherwise false
255linux_config_bin_exists() {
256 export _LINUX_CONFIG_EXISTS_DONE=1
257 [ -n "${I_KNOW_WHAT_I_AM_DOING}" -a -s "/proc/config.gz" ]
258}
259
260# @FUNCTION: linux_config_exists
261# @RETURN: true or false
262# @DESCRIPTION:
263# It returns true if .config exists otherwise false
264#
265# This function MUST be checked before using any of the linux_chkconfig_*
266# functions.
267linux_config_exists() {
268 linux_config_src_exists || linux_config_bin_exists
269}
270
271# @FUNCTION: require_configured_kernel
272# @DESCRIPTION:
273# This function verifies that the current kernel is configured (it checks against the existence of .config)
274# otherwise it dies.
275require_configured_kernel() {
276 if ! linux_config_src_exists; then
277 qeerror "Could not find a usable .config in the kernel source directory."
278 qeerror "Please ensure that ${KERNEL_DIR} points to a configured set of Linux sources."
279 qeerror "If you are using KBUILD_OUTPUT, please set the environment var so that"
280 qeerror "it points to the necessary object directory so that it might find .config."
281 die "Kernel not configured; no .config found in ${KV_OUT_DIR}"
282 fi
283}
284
285# @FUNCTION: linux_chkconfig_present
286# @USAGE: option
287# @RETURN: true or false
288# @DESCRIPTION:
289# It checks that CONFIG_<option>=y or CONFIG_<option>=m is present in the current kernel .config
290# If linux_config_exists returns false, the results of this are UNDEFINED. You
291# MUST call linux_config_exists first.
130linux_chkconfig_present() { 292linux_chkconfig_present() {
293 linux_config_qa_check linux_chkconfig_present
131local RESULT 294 local RESULT
295 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
296 local config
297 config="${KV_OUT_DIR}/.config"
298 [ ! -f "${config}" ] && config="/proc/config.gz"
132 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)" 299 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
133 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1 300 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1
134} 301}
135 302
303# @FUNCTION: linux_chkconfig_module
304# @USAGE: option
305# @RETURN: true or false
306# @DESCRIPTION:
307# It checks that CONFIG_<option>=m is present in the current kernel .config
308# If linux_config_exists returns false, the results of this are UNDEFINED. You
309# MUST call linux_config_exists first.
136linux_chkconfig_module() { 310linux_chkconfig_module() {
311 linux_config_qa_check linux_chkconfig_module
137local RESULT 312 local RESULT
313 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
314 local config
315 config="${KV_OUT_DIR}/.config"
316 [ ! -f "${config}" ] && config="/proc/config.gz"
138 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)" 317 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
139 [ "${RESULT}" = "m" ] && return 0 || return 1 318 [ "${RESULT}" = "m" ] && return 0 || return 1
140} 319}
141 320
321# @FUNCTION: linux_chkconfig_builtin
322# @USAGE: option
323# @RETURN: true or false
324# @DESCRIPTION:
325# It checks that CONFIG_<option>=y is present in the current kernel .config
326# If linux_config_exists returns false, the results of this are UNDEFINED. You
327# MUST call linux_config_exists first.
142linux_chkconfig_builtin() { 328linux_chkconfig_builtin() {
329 linux_config_qa_check linux_chkconfig_builtin
143local RESULT 330 local RESULT
331 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
332 local config
333 config="${KV_OUT_DIR}/.config"
334 [ ! -f "${config}" ] && config="/proc/config.gz"
144 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)" 335 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
145 [ "${RESULT}" = "y" ] && return 0 || return 1 336 [ "${RESULT}" = "y" ] && return 0 || return 1
146} 337}
147 338
339# @FUNCTION: linux_chkconfig_string
340# @USAGE: option
341# @RETURN: CONFIG_<option>
342# @DESCRIPTION:
343# It prints the CONFIG_<option> value of the current kernel .config (it requires a configured kernel).
344# If linux_config_exists returns false, the results of this are UNDEFINED. You
345# MUST call linux_config_exists first.
148linux_chkconfig_string() { 346linux_chkconfig_string() {
347 linux_config_qa_check linux_chkconfig_string
348 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
349 local config
350 config="${KV_OUT_DIR}/.config"
351 [ ! -f "${config}" ] && config="/proc/config.gz"
149 getfilevar "CONFIG_${1}" "${KV_OUT_DIR}/.config" 352 getfilevar_noexec "CONFIG_${1}" "${config}"
150} 353}
151 354
152# Versioning Functions 355# Versioning Functions
153# --------------------------------------- 356# ---------------------------------------
154 357
155# kernel_is returns true when the version is the same as the passed version 358# @FUNCTION: kernel_is
359# @USAGE: [-lt -gt -le -ge -eq] major_number [minor_number patch_number]
360# @RETURN: true or false
361# @DESCRIPTION:
362# It returns true when the current kernel version satisfies the comparison against the passed version.
363# -eq is the default comparison.
156# 364#
365# @CODE
157# For Example where KV = 2.6.9 366# For Example where KV = 2.6.9
158# kernel_is 2 4 returns false 367# kernel_is 2 4 returns false
159# kernel_is 2 returns true 368# kernel_is 2 returns true
160# kernel_is 2 6 returns true 369# kernel_is 2 6 returns true
161# kernel_is 2 6 8 returns false 370# kernel_is 2 6 8 returns false
162# kernel_is 2 6 9 returns true 371# kernel_is 2 6 9 returns true
163# 372# @CODE
373
164# got the jist yet? 374# got the jist yet?
165 375
166kernel_is() { 376kernel_is() {
167 # if we haven't determined the version yet, we need too. 377 # if we haven't determined the version yet, we need to.
168 get_version; 378 linux-info_get_any_version
379
169 local operator test value x=0 y=0 z=0 380 local operator test value x=0 y=0 z=0
170 381
171 case ${1} in 382 case ${1} in
172 lt) operator="-lt"; shift;; 383 -lt|lt) operator="-lt"; shift;;
173 gt) operator="-gt"; shift;; 384 -gt|gt) operator="-gt"; shift;;
174 le) operator="-le"; shift;; 385 -le|le) operator="-le"; shift;;
175 ge) operator="-ge"; shift;; 386 -ge|ge) operator="-ge"; shift;;
176 eq) operator="-eq"; shift;; 387 -eq|eq) operator="-eq"; shift;;
177 *) operator="-eq";; 388 *) operator="-eq";;
178 esac 389 esac
179 390
180 for x in ${@}; do 391 for x in ${@}; do
181 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done 392 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done
182 value="${value}${x}" 393 value="${value}${x}"
209 done 420 done
210 x=${x/ /} 421 x=${x/ /}
211 echo ${x} 422 echo ${x}
212} 423}
213 424
425# internal variable, so we know to only print the warning once
426get_version_warning_done=
427
428# @FUNCTION: get_version
429# @DESCRIPTION:
430# It gets the version of the kernel inside KERNEL_DIR and populates the KV_FULL variable
431# (if KV_FULL is already set it does nothing).
432#
433# The kernel version variables (KV_MAJOR, KV_MINOR, KV_PATCH, KV_EXTRA and KV_LOCAL) are also set.
434#
435# The KV_DIR is set using the KERNEL_DIR env var, the KV_DIR_OUT is set using a valid
436# KBUILD_OUTPUT (in a decreasing priority list, we look for the env var, makefile var or the
437# symlink /lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}/build).
214get_version() { 438get_version() {
215 local kbuild_output 439 local kbuild_output
216 440
217 # no need to execute this twice assuming KV_FULL is populated. 441 # no need to execute this twice assuming KV_FULL is populated.
218 # we can force by unsetting KV_FULL 442 # we can force by unsetting KV_FULL
221 # if we dont know KV_FULL, then we need too. 445 # if we dont know KV_FULL, then we need too.
222 # make sure KV_DIR isnt set since we need to work it out via KERNEL_DIR 446 # make sure KV_DIR isnt set since we need to work it out via KERNEL_DIR
223 unset KV_DIR 447 unset KV_DIR
224 448
225 # KV_DIR will contain the full path to the sources directory we should use 449 # KV_DIR will contain the full path to the sources directory we should use
450 [ -z "${get_version_warning_done}" ] && \
226 qeinfo "Determining the location of the kernel source code" 451 qeinfo "Determining the location of the kernel source code"
227 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})" 452 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})"
228 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}" 453 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}"
229 454
230 if [ -z "${KV_DIR}" ] 455 if [ -z "${KV_DIR}" ]
231 then 456 then
457 if [ -z "${get_version_warning_done}" ]; then
458 get_version_warning_done=1
232 qeerror "Unable to find kernel sources at ${KERNEL_DIR}" 459 qeerror "Unable to find kernel sources at ${KERNEL_DIR}"
233 qeinfo "This package requires Linux sources." 460 #qeinfo "This package requires Linux sources."
234 if [ "${KERNEL_DIR}" == "/usr/src/linux" ] ; then 461 if [ "${KERNEL_DIR}" == "/usr/src/linux" ] ; then
235 qeinfo "Please make sure that ${KERNEL_DIR} points at your running kernel, " 462 qeinfo "Please make sure that ${KERNEL_DIR} points at your running kernel, "
236 qeinfo "(or the kernel you wish to build against)." 463 qeinfo "(or the kernel you wish to build against)."
237 qeinfo "Alternatively, set the KERNEL_DIR environment variable to the kernel sources location" 464 qeinfo "Alternatively, set the KERNEL_DIR environment variable to the kernel sources location"
238 else 465 else
239 qeinfo "Please ensure that the KERNEL_DIR environment variable points at full Linux sources of the kernel you wish to compile against." 466 qeinfo "Please ensure that the KERNEL_DIR environment variable points at full Linux sources of the kernel you wish to compile against."
467 fi
240 fi 468 fi
241 return 1 469 return 1
242 fi 470 fi
243 471
472 if [ -z "${get_version_warning_done}" ]; then
244 qeinfo "Found kernel source directory:" 473 qeinfo "Found kernel source directory:"
245 qeinfo " ${KV_DIR}" 474 qeinfo " ${KV_DIR}"
475 fi
246 476
247 if [ ! -s "${KV_DIR}/Makefile" ] 477 if [ ! -s "${KV_DIR}/Makefile" ]
248 then 478 then
479 if [ -z "${get_version_warning_done}" ]; then
480 get_version_warning_done=1
249 qeerror "Could not find a Makefile in the kernel source directory." 481 qeerror "Could not find a Makefile in the kernel source directory."
250 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources" 482 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources"
483 fi
251 return 1 484 return 1
252 fi 485 fi
253 486
254 # OK so now we know our sources directory, but they might be using 487 # OK so now we know our sources directory, but they might be using
255 # KBUILD_OUTPUT, and we need this for .config and localversions-* 488 # KBUILD_OUTPUT, and we need this for .config and localversions-*
256 # so we better find it eh? 489 # so we better find it eh?
257 # do we pass KBUILD_OUTPUT on the CLI? 490 # do we pass KBUILD_OUTPUT on the CLI?
258 OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}" 491 OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}"
259 492
260 # And if we didn't pass it, we can take a nosey in the Makefile 493 # And if we didn't pass it, we can take a nosey in the Makefile
261 kbuild_output="$(getfilevar KBUILD_OUTPUT ${KV_DIR}/Makefile)" 494 kbuild_output="$(getfilevar_noexec KBUILD_OUTPUT ${KV_DIR}/Makefile)"
262 OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}" 495 OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}"
263 496
264 # And contrary to existing functions I feel we shouldn't trust the 497 # And contrary to existing functions I feel we shouldn't trust the
265 # directory name to find version information as this seems insane. 498 # directory name to find version information as this seems insane.
266 # so we parse ${KV_DIR}/Makefile 499 # so we parse ${KV_DIR}/Makefile
267 KV_MAJOR="$(getfilevar VERSION ${KV_DIR}/Makefile)" 500 KV_MAJOR="$(getfilevar_noexec VERSION ${KV_DIR}/Makefile)"
268 KV_MINOR="$(getfilevar PATCHLEVEL ${KV_DIR}/Makefile)" 501 KV_MINOR="$(getfilevar_noexec PATCHLEVEL ${KV_DIR}/Makefile)"
269 KV_PATCH="$(getfilevar SUBLEVEL ${KV_DIR}/Makefile)" 502 KV_PATCH="$(getfilevar_noexec SUBLEVEL ${KV_DIR}/Makefile)"
270 KV_EXTRA="$(getfilevar EXTRAVERSION ${KV_DIR}/Makefile)" 503 KV_EXTRA="$(getfilevar_noexec EXTRAVERSION ${KV_DIR}/Makefile)"
271 504
272 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ] 505 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ]
273 then 506 then
507 if [ -z "${get_version_warning_done}" ]; then
508 get_version_warning_done=1
274 qeerror "Could not detect kernel version." 509 qeerror "Could not detect kernel version."
275 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources." 510 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources."
511 fi
276 return 1 512 return 1
277 fi 513 fi
278 514
279 # and in newer versions we can also pull LOCALVERSION if it is set. 515 # and in newer versions we can also pull LOCALVERSION if it is set.
280 # but before we do this, we need to find if we use a different object directory. 516 # but before we do this, we need to find if we use a different object directory.
281 # This *WILL* break if the user is using localversions, but we assume it was 517 # This *WILL* break if the user is using localversions, but we assume it was
282 # caught before this if they are. 518 # caught before this if they are.
283 [ "${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.${KV_EXTRA}" == "$(uname -r)" ] && \ 519 [ "${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}" == "$(uname -r)" ] && \
284 OUTPUT_DIR="${OUTPUT_DIR:-/lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.${KV_EXTRA}/build}" 520 OUTPUT_DIR="${OUTPUT_DIR:-/lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}/build}"
285 521
286 [ -h "${OUTPUT_DIR}" ] && KV_OUT_DIR="$(readlink -f ${OUTPUT_DIR})" 522 [ -h "${OUTPUT_DIR}" ] && KV_OUT_DIR="$(readlink -f ${OUTPUT_DIR})"
287 [ -d "${OUTPUT_DIR}" ] && KV_OUT_DIR="${OUTPUT_DIR}" 523 [ -d "${OUTPUT_DIR}" ] && KV_OUT_DIR="${OUTPUT_DIR}"
288 if [ -n "${KV_OUT_DIR}" ]; 524 if [ -n "${KV_OUT_DIR}" ];
289 then 525 then
290 qeinfo "Found kernel object directory:" 526 qeinfo "Found kernel object directory:"
291 qeinfo " ${KV_OUT_DIR}" 527 qeinfo " ${KV_OUT_DIR}"
292 528
293 KV_LOCAL="$(get_localversion ${KV_OUT_DIR})" 529 KV_LOCAL="$(get_localversion ${KV_OUT_DIR})"
294 fi 530 fi
295 # and if we STILL haven't got it, then we better just set it to KV_DIR 531 # and if we STILL have not got it, then we better just set it to KV_DIR
296 KV_OUT_DIR="${KV_OUT_DIR:-${KV_DIR}}" 532 KV_OUT_DIR="${KV_OUT_DIR:-${KV_DIR}}"
297 533
298 KV_LOCAL="${KV_LOCAL}$(get_localversion ${KV_DIR})" 534 KV_LOCAL="${KV_LOCAL}$(get_localversion ${KV_DIR})"
535 if linux_config_src_exists; then
299 KV_LOCAL="${KV_LOCAL}$(linux_chkconfig_string LOCALVERSION)" 536 KV_LOCAL="${KV_LOCAL}$(linux_chkconfig_string LOCALVERSION)"
300 KV_LOCAL="${KV_LOCAL//\"/}" 537 KV_LOCAL="${KV_LOCAL//\"/}"
538
539 # For things like git that can append extra stuff:
540 [ -e ${KV_DIR}/scripts/setlocalversion ] &&
541 linux_chkconfig_builtin LOCALVERSION_AUTO &&
542 KV_LOCAL="${KV_LOCAL}$(sh ${KV_DIR}/scripts/setlocalversion ${KV_DIR})"
543 fi
301 544
302 # And we should set KV_FULL to the full expanded version 545 # And we should set KV_FULL to the full expanded version
303 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}" 546 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}"
304 547
305 qeinfo "Found sources for kernel version:" 548 qeinfo "Found sources for kernel version:"
306 qeinfo " ${KV_FULL}" 549 qeinfo " ${KV_FULL}"
307 550
308 if [ ! -s "${KV_OUT_DIR}/.config" ]
309 then
310 qeerror "Could not find a usable .config in the kernel source directory."
311 qeerror "Please ensure that ${KERNEL_DIR} points to a configured set of Linux sources."
312 qeerror "If you are using KBUILD_OUTPUT, please set the environment var so that"
313 qeerror "it points to the necessary object directory so that it might find .config."
314 return 1
315 fi
316
317 return 0 551 return 0
318} 552}
319 553
554# @FUNCTION: get_running_version
555# @DESCRIPTION:
556# It gets the version of the current running kernel and the result is the same as get_version() if the
557# function can find the sources.
320get_running_version() { 558get_running_version() {
321 KV_FULL=$(uname -r) 559 KV_FULL=$(uname -r)
322 560
323 if [[ -f ${ROOT}/lib/modules/${KV_FULL}/source/Makefile ]]; then 561 if [[ -f ${ROOT}/lib/modules/${KV_FULL}/source/Makefile ]]; then
324 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/source) 562 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/source)
339 && KV_EXTRA="-${KV_FULL#*-}" 577 && KV_EXTRA="-${KV_FULL#*-}"
340 fi 578 fi
341 return 0 579 return 0
342} 580}
343 581
582# This next function is named with the eclass prefix to avoid conflicts with
583# some old versionator-like eclass functions.
584
585# @FUNCTION: linux-info_get_any_version
586# @DESCRIPTION:
587# This attempts to find the version of the sources, and otherwise falls back to
588# the version of the running kernel.
589linux-info_get_any_version() {
590 get_version
591 if [[ $? -ne 0 ]]; then
592 ewarn "Unable to calculate Linux Kernel version for build, attempting to use running version"
593 get_running_version
594 fi
595}
596
344 597
345# ebuild check functions 598# ebuild check functions
346# --------------------------------------- 599# ---------------------------------------
347 600
601# @FUNCTION: check_kernel_built
602# @DESCRIPTION:
603# This function verifies that the current kernel sources have been already prepared otherwise it dies.
348check_kernel_built() { 604check_kernel_built() {
349 # if we haven't determined the version yet, we need too. 605 # if we haven't determined the version yet, we need to
606 require_configured_kernel
350 get_version; 607 get_version
351 608
352 if [ ! -f "${KV_OUT_DIR}/include/linux/version.h" ] 609 if [ ! -f "${KV_OUT_DIR}/include/linux/version.h" ]
353 then 610 then
354 eerror "These sources have not yet been prepared." 611 eerror "These sources have not yet been prepared."
355 eerror "We cannot build against an unprepared tree." 612 eerror "We cannot build against an unprepared tree."
362 eerror "Then please try merging this module again." 619 eerror "Then please try merging this module again."
363 die "Kernel sources need compiling first" 620 die "Kernel sources need compiling first"
364 fi 621 fi
365} 622}
366 623
624# @FUNCTION: check_modules_supported
625# @DESCRIPTION:
626# This function verifies that the current kernel support modules (it checks CONFIG_MODULES=y) otherwise it dies.
367check_modules_supported() { 627check_modules_supported() {
368 # if we haven't determined the version yet, we need too. 628 # if we haven't determined the version yet, we need too.
629 require_configured_kernel
369 get_version; 630 get_version
370 631
371 if ! linux_chkconfig_builtin "MODULES" 632 if ! linux_chkconfig_builtin "MODULES"
372 then 633 then
373 eerror "These sources do not support loading external modules." 634 eerror "These sources do not support loading external modules."
374 eerror "to be able to use this module please enable \"Loadable modules support\"" 635 eerror "to be able to use this module please enable \"Loadable modules support\""
375 eerror "in your kernel, recompile and then try merging this module again." 636 eerror "in your kernel, recompile and then try merging this module again."
376 die "No support for external modules in ${KV_FULL} config" 637 die "No support for external modules in ${KV_FULL} config"
377 fi 638 fi
378} 639}
379 640
641# @FUNCTION: check_extra_config
642# @DESCRIPTION:
643# It checks the kernel config options specified by CONFIG_CHECK. It dies only when a required config option (i.e.
644# the prefix ~ is not used) doesn't satisfy the directive.
380check_extra_config() { 645check_extra_config() {
381 local config negate error local_error i n
382 local temp_config die reworkmodulenames 646 local config negate die error reworkmodulenames
647 local soft_errors_count=0 hard_errors_count=0 config_required=0
648 # store the value of the QA check, because otherwise we won't catch usages
649 # after if check_extra_config is called AND other direct calls are done
650 # later.
651 local old_LINUX_CONFIG_EXISTS_DONE="${_LINUX_CONFIG_EXISTS_DONE}"
383 652
384 # if we haven't determined the version yet, we need too. 653 # if we haven't determined the version yet, we need to
385 get_version; 654 linux-info_get_any_version
386 655
656 # Determine if we really need a .config. The only time when we don't need
657 # one is when all of the CONFIG_CHECK options are prefixed with "~".
658 for config in ${CONFIG_CHECK}
659 do
660 if [[ "${config:0:1}" != "~" ]]; then
661 config_required=1
662 break
663 fi
664 done
665
666 # TODO: After we enable the new code for /proc/config.gz, we need to
667 # change this back to linux_config_exists.
668 if [[ ${config_required} == 0 ]]; then
669 # In the case where we don't require a .config, we can now bail out
670 # if the user has no .config as there is nothing to do. Otherwise
671 # code later will cause a failure due to missing .config.
672 if ! linux_config_src_exists; then
673 ewarn "Unable to check for the following kernel config options due"
674 ewarn "to absence of any configured kernel sources or compiled"
675 ewarn "config:"
676 for config in ${CONFIG_CHECK}; do
677 local_error="ERROR_${config#\~}"
678 msg="${!local_error}"
679 if [[ "x${msg}" == "x" ]]; then
680 local_error="WARNING_${config#\~}"
681 msg="${!local_error}"
682 fi
683 ewarn " - ${config#\~}${msg:+ - }${msg}"
684 done
685 ewarn "You're on your own to make sure they are set if needed."
686 export LINUX_CONFIG_EXISTS_DONE="${old_LINUX_CONFIG_EXISTS_DONE}"
687 return 0
688 fi
689 else
690 [ -n "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
691 fi
692
387 einfo "Checking for suitable kernel configuration options:" 693 einfo "Checking for suitable kernel configuration options..."
694
388 for config in ${CONFIG_CHECK} 695 for config in ${CONFIG_CHECK}
389 do 696 do
390 # if we specify any fatal, ensure we honor them 697 # if we specify any fatal, ensure we honor them
391 die=1 698 die=1
392 error=0 699 error=0
393 negate=0 700 negate=0
394 reworkmodulenames=0 701 reworkmodulenames=0
395 702
396 if [[ -z ${config//\!*} ]]; then 703 if [[ ${config:0:1} == "~" ]]; then
397 negate=1 704 die=0
398 config=${config:1} 705 config=${config:1}
399 fi 706 elif [[ ${config:0:1} == "@" ]]; then
400 if [[ -z ${config/\@*} ]]; then
401 die=2 707 die=0
402 reworkmodulenames=1 708 reworkmodulenames=1
403 config=${config:1} 709 config=${config:1}
404 fi 710 fi
405 if [[ -z ${config/\~*} ]]; then 711 if [[ ${config:0:1} == "!" ]]; then
406 die=0 712 negate=1
407 config=${config:1} 713 config=${config:1}
408 fi 714 fi
409 715
410 if [[ ${negate} == 1 ]]; then 716 if [[ ${negate} == 1 ]]; then
411 linux_chkconfig_present ${config} && error=2 717 linux_chkconfig_present ${config} && error=2
412 elif [[ ${reworkmodulenames} == 1 ]]; then 718 elif [[ ${reworkmodulenames} == 1 ]]; then
413 temp_config="${config//*:}" 719 local temp_config="${config//*:}" i n
414 config="${config//:*}" 720 config="${config//:*}"
415 if linux_chkconfig_present ${config}; then 721 if linux_chkconfig_present ${config}; then
416 for i in ${MODULE_NAMES}; do 722 for i in ${MODULE_NAMES}; do
417 n="${i//${temp_config}}" 723 n="${i//${temp_config}}"
418 [[ -z ${n//\(*} ]] && \ 724 [[ -z ${n//\(*} ]] && \
422 fi 728 fi
423 else 729 else
424 linux_chkconfig_present ${config} || error=1 730 linux_chkconfig_present ${config} || error=1
425 fi 731 fi
426 732
427 if [[ ${die} == 0 ]]; then
428 ebegin "CONFIG_${config}"
429 eend ${error}
430 else
431 if [[ ${error} > 0 ]]; then 733 if [[ ${error} > 0 ]]; then
734 local report_func="eerror" local_error
432 local_error="ERROR_${config}" 735 local_error="ERROR_${config}"
736 local_error="${!local_error}"
737
738 if [[ -z "${local_error}" ]]; then
739 # using old, deprecated format.
740 local_error="${config}_ERROR"
433 local_error="${!local_error}" 741 local_error="${!local_error}"
434 742 fi
435 if [[ -z "${local_error}" ]]; then 743 if [[ ${die} == 0 && -z "${local_error}" ]]; then
436 # using old, deprecated format. 744 #soft errors can be warnings
437 local_error="${config}_ERROR" 745 local_error="WARNING_${config}"
438 local_error="${!local_error}" 746 local_error="${!local_error}"
747 if [[ -n "${local_error}" ]] ; then
748 report_func="ewarn"
439 fi 749 fi
440
441 if [[ -z "${local_error}" ]]; then
442 [[ ${error} == 1 ]] \
443 && local_error="is not set when it should be." \
444 || local_error="should not be set. But it is."
445 local_error="CONFIG_${config}:\t ${local_error}"
446 fi
447 eerror " ${local_error}"
448 fi 750 fi
751
752 if [[ -z "${local_error}" ]]; then
753 [[ ${error} == 1 ]] \
754 && local_error="is not set when it should be." \
755 || local_error="should not be set. But it is."
756 local_error="CONFIG_${config}:\t ${local_error}"
757 fi
758 if [[ ${die} == 0 ]]; then
759 ${report_func} " ${local_error}"
760 soft_errors_count=$[soft_errors_count + 1]
761 else
762 ${report_func} " ${local_error}"
763 hard_errors_count=$[hard_errors_count + 1]
764 fi
449 fi 765 fi
450 done 766 done
451 767
452 if [[ ${error} > 0 ]]; then 768 if [[ ${hard_errors_count} > 0 ]]; then
453 eerror "Please check to make sure these options are set correctly." 769 eerror "Please check to make sure these options are set correctly."
454 eerror "Failure to do so may cause unexpected problems." 770 eerror "Failure to do so may cause unexpected problems."
455 if [[ ${die} == 1 ]]; then
456 eerror "Once you have satisfied these options, please try merging" 771 eerror "Once you have satisfied these options, please try merging"
457 eerror "this package again." 772 eerror "this package again."
773 export LINUX_CONFIG_EXISTS_DONE="${old_LINUX_CONFIG_EXISTS_DONE}"
458 die "Incorrect kernel configuration options" 774 die "Incorrect kernel configuration options"
775 elif [[ ${soft_errors_count} > 0 ]]; then
776 ewarn "Please check to make sure these options are set correctly."
777 ewarn "Failure to do so may cause unexpected problems."
778 else
779 eend 0
459 fi 780 fi
460 fi 781 export LINUX_CONFIG_EXISTS_DONE="${old_LINUX_CONFIG_EXISTS_DONE}"
461} 782}
462 783
463check_zlibinflate() { 784check_zlibinflate() {
464 # if we haven't determined the version yet, we need too. 785 # if we haven't determined the version yet, we need to
786 require_configured_kernel
465 get_version; 787 get_version
466 788
467 # although I restructured this code - I really really really dont support it! 789 # although I restructured this code - I really really really dont support it!
468 790
469 # bug #27882 - zlib routines are only linked into the kernel 791 # bug #27882 - zlib routines are only linked into the kernel
470 # if something compiled into the kernel calls them 792 # if something compiled into the kernel calls them
477 local DEFLATE 799 local DEFLATE
478 800
479 einfo "Determining the usability of ZLIB_INFLATE support in your kernel" 801 einfo "Determining the usability of ZLIB_INFLATE support in your kernel"
480 802
481 ebegin "checking ZLIB_INFLATE" 803 ebegin "checking ZLIB_INFLATE"
482 getfilevar_isbuiltin CONFIG_ZLIB_INFLATE ${KV_DIR}/.config 804 linux_chkconfig_builtin CONFIG_ZLIB_INFLATE
483 eend $? 805 eend $?
484 [ "$?" != 0 ] && die 806 [ "$?" != 0 ] && die
485 807
486 ebegin "checking ZLIB_DEFLATE" 808 ebegin "checking ZLIB_DEFLATE"
487 getfilevar_isbuiltin CONFIG_ZLIB_DEFLATE ${KV_DIR}/.config 809 linux_chkconfig_builtin CONFIG_ZLIB_DEFLATE
488 eend $? 810 eend $?
489 [ "$?" != 0 ] && die 811 [ "$?" != 0 ] && die
490 812
491 local LINENO_START 813 local LINENO_START
492 local LINENO_END 814 local LINENO_END
530} 852}
531 853
532################################ 854################################
533# Default pkg_setup 855# Default pkg_setup
534# Also used when inheriting linux-mod to force a get_version call 856# Also used when inheriting linux-mod to force a get_version call
535 857# @FUNCTION: linux-info_pkg_setup
858# @DESCRIPTION:
859# Force a get_version() call when inherited from linux-mod.eclass and then check if the kernel is configured
860# to support the options specified in CONFIG_CHECK (if not null)
536linux-info_pkg_setup() { 861linux-info_pkg_setup() {
537 get_version || die "Unable to calculate Linux Kernel version" 862 linux-info_get_any_version
863
864 if kernel_is 2 4; then
865 if [ "$( gcc-major-version )" -eq "4" ] ; then
866 echo
867 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with"
868 ewarn "linux-2.4 (or modules building against a linux-2.4 kernel)!"
869 echo
870 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
871 ewarn "newer kernel that supports gcc-4."
872 echo
873 ewarn "Also be aware that bugreports about gcc-4 not working"
874 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
875 echo
876 epause 10
877 fi
878 fi
879
538 [ -n "${CONFIG_CHECK}" ] && check_extra_config; 880 [ -n "${CONFIG_CHECK}" ] && check_extra_config;
539} 881}

Legend:
Removed from v.1.39  
changed lines
  Added in v.1.77

  ViewVC Help
Powered by ViewVC 1.1.20